# xcvbnm

This is a dart port of the great [dropbox/zxcvbn](https://github.com/dropbox/zxcvbn) library, a realistic password strength 
estimator.

This library can be used on the server and in the browser.

Keep in mind that the dictionary is quite big, so using it in the browser comes
with a substantial increase of the script size.

**Please note, that library did not port all functionality but is already used in production.**

## Usage

```dart
library xcvbnm.example.bin;

import 'package:xcvbnm/xcvbnm.dart';

main() {
  String password = "my_pwd_1";
  // Use the direct helper API
  Result result = new Xcvbnm().estimate(password);
  print(result.toMap());
}
```


## Demo

### Command line

```bash
$  dart bin/xcvbnm.dart --help
  -h, --help     Usage help
  -m, --match    Max number max of match to display
                 (defaults to "4")
$ dart bin/xcvbnm.dart
$ dart bin/xcvbnm.dart 9IOksjdopwd
$ dart bin/xcvbnm.dart "my password"
$ dart bin/xcvbnm.dart pwd1 pwd2 -m 1
```

## Development

### Guidelines and format

Before each commit format at the root of the project

```bash
$ dartfmt -w .
```
    
### Test

Run all tests in multiple platforms

```bash
$ ./test/bin/run_tests.sh
```
    
